/*
*
*  RMHashtable.java
*
*  SPECT: Simple Portal-Enhancing Configuration Tool
*  Copyright (C) 1999, 2000 Ray Ontko & Co.
*  http://www.ontko.com/
*
*  This program is a simple-to-use configuration tool for Brio.Portal
*  (formerly ReportMart).
*
*  "Brio.Portal" is a trademark of Brio Technology, http://www.brio.com/ .
* 
* 
*  This program is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by 
*  the Free Software Foundation; either version 2 of the License, or 
*  (at your option) any later version. 
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of 
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
*  Public License for more details. 
* 
*  A copy of the GPL is available online the GNU web site: 
* 
*    http://www.gnu.org/copyleft/gpl.html
* 
*/ 

import java.util.*;

/*****************************************************************
*
* RMHashtable is simply a hashtable that uses a recursive, deep clone,
* rather than the shallow clone of the normal Hashtable.  clone() creates
* a new RMHashtable and populates it with clones of the members of the 
* original RMHashtable.
*
****************************************************************/
class RMHashtable extends Hashtable {
   public synchronized Object clone() { // overrides Hashtable.clone()
      RMHashtable temp;
      String key;
      RMProperty value;
      temp = new RMHashtable();
      Enumeration keys = this.keys();
      while (keys.hasMoreElements()) {
         key = (String)keys.nextElement();
         value = (RMProperty)this.get(key);
         temp.put(new String(key), value.clone());
      }
      return temp;
   }
}


   
